#!/usr/bin/perl -w
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
#
# The Original Code is the Bugzilla Bug Tracking System.
#
# The Initial Developer of the Original Code is Netscape Communications
# Corporation. Portions created by Netscape are
# Copyright (C) 1998 Netscape Communications Corporation. All
# Rights Reserved.
#
# Contributor(s): Dave Miller <justdave@syndicomm.com>
#                 Jake Steenhagen <jake@acutexx.net>

# Code derived from editowners.cgi and editusers.cgi

use diagnostics;
use strict;
use lib ".";

require "CGI.pl";

ConnectToDatabase();
confirm_login();

print "Content-Type: text/html; charset=EUC-KR\n\n";

if (!UserInGroup("creategroups")) {
    PutHeader(" ϴ","׷ ϱ","","    ϴ!");
    print "<H1>˼մϴٸ, ϲ ׷   ִ 'creategroups' ׷  ƴմϴ.</H1>\n";
    print " ׷ Ͻ  ϴ.\n";
    print "<p>\n";
    PutFooter();
    exit;
}

my $action  = trim($::FORM{action} || '');

# TestGroup: check if the group name exists
sub TestGroup ($)
{
    my $group = shift;

    # does the group exist?
    SendSQL("SELECT name
             FROM groups
             WHERE name=" . SqlQuote($group));
    return FetchOneColumn();
}

sub ShowError ($)
{
    my $msgtext = shift;
    print "<TABLE BGCOLOR=\"#FF0000\" CELLPADDING=15><TR><TD>";
    print "<B>$msgtext</B>";
    print "</TD></TR></TABLE><P>";
    return 1;
}

#
# Displays a text like "a.", "a or b.", "a, b or c.", "a, b, c or d."
#

sub PutTrailer (@)
{
    my (@links) = ("<a href=\"./\">   ư</a>", @_);

    my $count = $#links;
    my $num = 0;
    print "<P>\n";
    foreach (@links) {
        print $_;
        if ($num == $count) {
            print ".\n";
        }
        elsif ($num == $count-1) {
            print " Ǵ ";
        }
        else {
            print ", ";
        }
        $num++;
    }
    PutFooter();
}

#
# action='' -> No action specified, get a list.
#

unless ($action) {
    PutHeader("׷ ϱ","׷ ϱ","  ڵ Ҽӵ ׷   ֽϴ.");

    print "<form method=post action=editgroups.cgi>\n";
    print "<table border=1>\n";
    print "<tr>";
    print "<th>Ʈ</th>";
    print "<th≯</th>";
    print "<th></th>";
    print "<th> ǥ</th>";
    print "<th>Ȱȭ</th>";
    print "<th>׼</th>";
    print "</tr>\n";

    SendSQL("SELECT bit,name,description,userregexp,isactive " .
            "FROM groups " .
            "WHERE isbuggroup != 0 " .
            "ORDER BY bit");

    while (MoreSQLData()) {
        my ($bit, $name, $desc, $regexp, $isactive) = FetchSQLData();
        print "<tr>\n";
        print "<td valign=middle>$bit</td>\n";
        print "<td><input size=20 name=\"name-$bit\" value=\"$name\">\n";
        print "<input type=hidden name=\"oldname-$bit\" value=\"$name\"></td>\n";
        print "<td><input size=40 name=\"desc-$bit\" value=\"$desc\">\n";
        print "<input type=hidden name=\"olddesc-$bit\" value=\"$desc\"></td>\n";
        print "<td><input size=30 name=\"regexp-$bit\" value=\"$regexp\">\n";
        print "<input type=hidden name=\"oldregexp-$bit\" value=\"$regexp\"></td>\n";
        print "<td><input type=\"checkbox\" name=\"isactive-$bit\" value=\"1\"" . ($isactive ? " checked" : "") . ">\n";
        print "<input type=hidden name=\"oldisactive-$bit\" value=\"$isactive\"></td>\n";
        print "<td align=center valign=middle><a href=\"editgroups.cgi?action=del&group=$bit\"></a></td>\n";
        print "</tr>\n";
    }

    print "<tr>\n";
    print "<td colspan=5></td>\n";
    print "<td><a href=\"editgroups.cgi?action=add\">׷ ߰ϱ</a></td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "<input type=hidden name=\"action\" value=\"update\">";
    print "<input type=submit value=\" ϱ\">\n";

    print "<p>";
    print "<b≯</b>  ۼ  cgi Ͽ ־ ׷ ϱ  ȣϴ
           UserInGroup() ϰ ˴ϴ.    ڵ email ׸  
           Ư ׷(groupset) Ͽ   ϱ ؼ   ֽϴ.<p>";
    print "<b></b>  ׸  ׷ ٸ ڿ     ֵ,
           ׷   Ʈ Ÿ ˴ϴ.<p>";
    print "<b> ǥ</b> (optional)ε,   ׸ ä Ǹ ο 
           ڸ   emailּҰ ⿡  ǥĿ ġϸ ڵ ش
           ׷쿡 Ҽӵǵ մϴ.<p>";
    print "<b>Ȱȭ</b> ÷״  ׷ Ȱȭ   Ȱȭ   Ǵϴµ մϴ.
           ׷ Ȱȭ Ű ش ׷쿡 Ҽӵ ڵ ׸ ߰ϴ    ֽϴ.
           ׷  , ׷ ü Ȱȭ Ű  ׷ ϴ ͺٴ ξ  
            Դϴ.<p>";
    print "÷ϸ,  ׷   ľϱ Ͽ ý  ִ ⺻ ׷Դϴ.
           Ʒ ׷鿡 ؼ  ǥĸ Ͻ  ֽϴ. ׷ ߰  ̵ ׷ 
           ̸ ߺ ʵ Ͻñ ٶϴ.<p>";
    print "   Ͽ ϴ ' ϱ' ư  ̺ θ ϰ 
           ȴٴµ Ͻʽÿ. ǻ   ư  Դϴ.<p>";

    print "<table border=1>\n";
    print "<tr>";
    print "<th>Ʈ</th>";
    print "<th≯</th>";
    print "<th></th>";
    print "<th> ǥ</th>";
    print "</tr>\n";

    SendSQL("SELECT bit,name,description,userregexp " .
            "FROM groups " .
            "WHERE isbuggroup = 0 " .
            "ORDER BY bit");

    while (MoreSQLData()) {
        my ($bit, $name, $desc, $regexp) = FetchSQLData();
        print "<tr>\n";
        print "<td>$bit</td>\n";
        print "<td>$name</td>\n";
        print "<input type=hidden name=\"name-$bit\" value=\"$name\">\n";
        print "<input type=hidden name=\"oldname-$bit\" value=\"$name\">\n";
        print "<td>$desc</td>\n";
        print "<td><input type=text size=30 name=\"regexp-$bit\" value=\"$regexp\"></td>\n";
        print "<input type=hidden name=\"oldregexp-$bit\" value=\"$regexp\">\n";
        print "</tr>\n";
    }

    print "</table><p>\n";
    print "<input type=submit value=\" ϱ\">\n";
    print "</form>\n";

    PutFooter();
    exit;
}

#
# action='add' -> present form for parameters for new group
#
# (next action will be 'new')
#

if ($action eq 'add') {
    PutHeader("׷ ߰ϱ");

    print "<FORM METHOD=POST ACTION=editgroups.cgi>\n";
    print "<TABLE BORDER=1 CELLPADDING=4 CELLSPACING=0><TR>\n";
    print "<th>ű ̸</th>";
    print "<th>ű </th>";
    print "<th>ű  ǥ</th>";
    print "<th>Ȱȭ</th>";
    print "</tr><tr>";
    print "<td><input size=20 name=\"name\"></td>\n";
    print "<td><input size=40 name=\"desc\"></td>\n";
    print "<td><input size=30 name=\"regexp\"></td>\n";
    print "<td><input type=\"checkbox\" name=\"isactive\" value=\"1\" checked></td>\n";
    print "</TR></TABLE>\n<HR>\n";
    print "<INPUT TYPE=SUBMIT VALUE=\"߰ϱ\">\n";
    print "<INPUT TYPE=HIDDEN NAME=\"action\" VALUE=\"new\">\n";
    print "</FORM>";

    print "<p>";
    print "<b≯</b>  ۼ  cgi Ͽ ־ ׷ ϱ  ȣϴ
           UserInGroup() ϰ ˴ϴ.    ڵ email ׸  
           Ư ׷(groupset) Ͽ   ϱ ؼ   ֽϴ.<p>";
    print "<b></b>  ׸  ׷ ٸ ڿ     ֵ,
           ׷   Ʈ Ÿ ˴ϴ.<p>";
    print "<b> ǥ</b> (optional)ε,   ׸ ä Ǹ ο 
           ڸ   emailּҰ ⿡  ǥĿ ġϸ ڵ ش
           ׷쿡 Ҽӵǵ մϴ.<p>";
    print "<b>Ȱȭ</b> ÷״  ׷ Ȱȭ   Ȱȭ   Ǵϴµ մϴ.
           ׷ Ȱȭ Ű ش ׷쿡 Ҽӵ ڵ ׸ ߰ϴ    ֽϴ.
           ׷  , ׷ ü Ȱȭ Ű  ׷ ϴ ͺٴ ξ  
            Դϴ.<p>";

    PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
    exit;
}



#
# action='new' -> add group entered in the 'action=add' screen
#

if ($action eq 'new') {
    PutHeader(" ׷ ϱ");

    # Cleanups and valididy checks
    my $name = trim($::FORM{name} || '');
    my $desc = trim($::FORM{desc} || '');
    my $regexp = trim($::FORM{regexp} || '');
    # convert an undefined value in the inactive field to zero
    # (this occurs when the inactive checkbox is not checked
    # and the browser does not send the field to the server)
    my $isactive = $::FORM{isactive} || 0;

    unless ($name) {
        ShowError(" ׷쿡  ̸ ݵ Էϼž߸ մϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.\n");
        PutFooter();
        exit;
    }
    unless ($desc) {
        ShowError(" ׷쿡   ݵ Էϼž߸ մϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.\n");
        PutFooter();
        exit;
    }
    if (TestGroup($name)) {
        ShowError("ԷϽ ̸ ׷('" . $name . "') ̹ մϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.\n");
        PutFooter();
        exit;
    }

    if ($isactive != 0 && $isactive != 1) {
        ShowError("Ȱȭ ʵ尡 ϰ Ǿϴ.   ְų " .
                  "  װ ִ  ϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.\n");
        PutFooter();
        exit;
    }

    # Major hack for bit values...  perl can't handle 64-bit ints, so I can't
    # just do the math to get the next available bit number, gotta handle
    # them as strings...  also, we're actually only going to allow 63 bits
    # because that's all that opblessgroupset masks for (the high bit is off
    # to avoid signing issues).

    my @bitvals = ('1','2','4','8','16','32','64','128','256','512','1024',
                   '2048','4096','8192','16384','32768',

                   '65536','131072','262144','524288','1048576','2097152',
                   '4194304','8388608','16777216','33554432','67108864',
                   '134217728','268435456','536870912','1073741824',
                   '2147483648',

                   '4294967296','8589934592','17179869184','34359738368',
                   '68719476736','137438953472','274877906944',
                   '549755813888','1099511627776','2199023255552',
                   '4398046511104','8796093022208','17592186044416',
                   '35184372088832','70368744177664','140737488355328',

                   '281474976710656','562949953421312','1125899906842624',
                   '2251799813685248','4503599627370496','9007199254740992',
                   '18014398509481984','36028797018963968','72057594037927936',
                   '144115188075855872','288230376151711744',
                   '576460752303423488','1152921504606846976',
                   '2305843009213693952','4611686018427387904');

    # First the next available bit
    my $bit = "";
    foreach (@bitvals) {
        if ($bit eq "") {
            SendSQL("SELECT bit FROM groups WHERE bit=" . SqlQuote($_));
            if (!FetchOneColumn()) { $bit = $_; }
        }
    }
    if ($bit eq "") {
        ShowError("˼մϴٸ, ϲ ִ ϰ ׷ ŭ ׷ ϼ̽ϴ." .
                  "<BR><BR> Ͻñ   ׷  ֽñ ٶϴ.</B>");
        PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
        exit;
    }

    # Add the new group
    SendSQL("INSERT INTO groups ( " .
            "bit, name, description, isbuggroup, userregexp, isactive" .
            " ) VALUES ( " .
            $bit . "," .
            SqlQuote($name) . "," .
            SqlQuote($desc) . "," .
            "1," .
            SqlQuote($regexp) . "," . 
            $isactive . ")" );

    print "OK, ϷǾϴ.<p>\n";
    print "  ׷쿡 #$bit Ʈ ҴǾϴ.<p>";
    PutTrailer("<a href=\"editgroups.cgi?action=add\">ٸ ׷ ߰ϱ</a>",
               "<a href=editgroups.cgi>׷ Ʈ ư</a>");
    exit;
}

#
# action='del' -> ask if user really wants to delete
#
# (next action would be 'delete')
#

if ($action eq 'del') {
    PutHeader("׷ ϱ");
    my $bit = trim($::FORM{group} || '');
    unless ($bit) {
        ShowError(" ׷  ʾҽϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.");
        PutFooter();
        exit;
    }
    SendSQL("SELECT bit FROM groups WHERE bit=" . SqlQuote($bit));
    if (!FetchOneColumn()) {
        ShowError("ش ׷  ʽϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.");
        PutFooter();
        exit;
    }
    SendSQL("SELECT name,description " .
            "FROM groups " .
            "WHERE bit = " . SqlQuote($bit));

    my ($name, $desc) = FetchSQLData();
    print "<table border=1>\n";
    print "<tr>";
    print "<th>Ʈ</th>";
    print "<th≯</th>";
    print "<th></th>";
    print "</tr>\n";
    print "<tr>\n";
    print "<td>$bit</td>\n";
    print "<td>$name</td>\n";
    print "<td>$desc</td>\n";
    print "</tr>\n";
    print "</table>\n";

    print "<FORM METHOD=POST ACTION=editgroups.cgi>\n";
    my $cantdelete = 0;
    SendSQL("SELECT login_name FROM profiles WHERE " .
            "(groupset & $bit) OR (blessgroupset & $bit)");
    if (!FetchOneColumn()) {} else {
       $cantdelete = 1;
       print "
<B>ϳ ̻ ڰ  ׷쿡 ϵǾ ֽϴ.  ׷쿡 ϴ ڸ ϱ  ׷ Ͻ  ϴ.</B><BR>
<A HREF=\"editusers.cgi?action=list&query=" .
url_quote("(groupset & $bit) OR (blessgroupset & $bit)") . "\">  ּ.</A> - <INPUT TYPE=CHECKBOX NAME=\"removeusers\"> ׷쿡   ڸ ּ<P>
";
    }
    SendSQL("SELECT bug_id FROM bugs WHERE (groupset & $bit)");
    if (MoreSQLData()) {
       $cantdelete = 1;
       my $buglist = "0";
       while (MoreSQLData()) {
         my ($bug) = FetchSQLData();
         $buglist .= "," . $bug;
       }
       print "
<B> ׷쿡 ̴(visible) װ ϳ ̻ մϴ. ̵ ׵ ׷  Ǵ ȿ ׷ Ͻ  ϴ.</B><BR>
<A HREF=\"buglist.cgi?bug_id=$buglist\">  ּ.</A> -
<INPUT TYPE=CHECKBOX NAME=\"removebugs\"> ׷쿡   ׵  ּ.<BR>
<B>:</B>  üũڽ üũϴ     ִ ׸  ɼ ֽϴ.
츮   ڽ üũϱ , ׷쿡  ׵ غ⸦ <B></B> ϴ
Դϴ.<P>
";
    }
    SendSQL("SELECT product FROM products WHERE product=" . SqlQuote($name));
    if (MoreSQLData()) {
       $cantdelete = 1;
       print "
<B> ׷ ǰ('<U>$name</U>') Ǿ ֽϴ.
ǰ Ǿ ִ ȿ ׷ Ͻ  ϴ.</B><BR>
<INPUT TYPE=CHECKBOX NAME=\"unbind\">e  ׷ Ͻð,
 ǰ('<U>$name</U>')  ڵ鿡  ּ.<BR>
";
    }

    print "<H2>Ȯλ</H2>\n";
    print "<P>  ׷ Ͻðڽϱ?\n";
    if ($cantdelete) {
      print "<BR><B>  üũڽ  Ͻðų, ϱ  " .
            "ĺ  Ͻñ ٶϴ.</B>";
    }
    print "<P><INPUT TYPE=SUBMIT VALUE=\", ϰڽϴ\">\n";
    print "<INPUT TYPE=HIDDEN NAME=\"action\" VALUE=\"delete\">\n";
    print "<INPUT TYPE=HIDDEN NAME=\"group\" VALUE=\"$bit\">\n";
    print "</FORM>";

    PutTrailer("<a href=editgroups.cgi>ƴϿ, ׷ Ʈ ưڽϴ.</a>");
    exit;
}

#
# action='delete' -> really delete the group
#

if ($action eq 'delete') {
    PutHeader("׷ ϱ");
    my $bit = trim($::FORM{group} || '');
    unless ($bit) {
        ShowError(" ׷  ʾҽϴ.<BR>" .
                  "<b>ڷ(Back)</b> ư ŬϽ  ٽ õ ֽʽÿ.");
        PutFooter();
        exit;
    }
    SendSQL("SELECT name " .
            "FROM groups " .
            "WHERE bit = " . SqlQuote($bit));
    my ($name) = FetchSQLData();

    my $cantdelete = 0;
    my $opblessgroupset = '9223372036854775807'; # This is all 64 bits.

    SendSQL("SELECT userid FROM profiles " .
            "WHERE (groupset & $opblessgroupset)=$opblessgroupset");
    my @opusers = ();
    while (MoreSQLData()) {
      my ($userid) = FetchSQLData();
      push @opusers, $userid; # cache a list of the users with admin powers
    }
    SendSQL("SELECT login_name FROM profiles WHERE " .
            "(groupset & $bit)=$bit OR (blessgroupset & $bit)=$bit");
    if (FetchOneColumn()) {
      if (!defined $::FORM{'removeusers'}) {
        $cantdelete = 1;
      }
    }
    SendSQL("SELECT bug_id FROM bugs WHERE (groupset & $bit)=$bit");
    if (FetchOneColumn()) {
      if (!defined $::FORM{'removebugs'}) {
        $cantdelete = 1;
      }
    }
    SendSQL("SELECT product FROM products WHERE product=" . SqlQuote($name));
    if (FetchOneColumn()) {
      if (!defined $::FORM{'unbind'}) {
        $cantdelete = 1;
      }
    }

    if ($cantdelete == 1) {
      ShowError("ͺ̽   ׷ ϴ ڽ(child) ڵ ϱ " .
                " ׷ Ͻ  ϴ. ׷ Ͻñ ,  ׷ " .
                "ϴ  ڽ ڵ  Ͻðų  Ͻñ " .
                "ٶϴ.");
      print "<A HREF=\"editgroups.cgi?action=del&group=$bit\">" .
            " ڵ  ޴ Ʈ ּ</A><BR>";
      PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
      exit;
    }

    SendSQL("SELECT login_name,groupset,blessgroupset FROM profiles WHERE " .
            "(groupset & $bit) OR (blessgroupset & $bit)");
    if (FetchOneColumn()) {
      SendSQL("UPDATE profiles SET groupset=(groupset-$bit) " .
              "WHERE (groupset & $bit)");
      print "׷ $b  ڵ Ǿϴ.<BR>";
      SendSQL("UPDATE profiles SET blessgroupset=(blessgroupset-$bit) " .
              "WHERE (blessgroupset & $bit)");
      print " ׷ $b Ҽӵ ڵ鿡 ο߾ ѵ  ȸϿϴ.<BR>";
    }
    SendSQL("SELECT bug_id FROM bugs WHERE (groupset & $bit)");
    if (FetchOneColumn()) {
      SendSQL("UPDATE bugs SET groupset=(groupset-$bit), delta_ts=delta_ts " .
              "WHERE (groupset & $bit)");
      print " ׿ ϴ ׷ Ʈ $bit Ͽϴ.  ׵   " .
            "׷쿡  ʴ ׵  ڵ鿡 Ǿϴ.<BR>";
    }
    SendSQL("DELETE FROM groups WHERE bit=$bit");
    print "<B>׷ $bit / Ǿϴ.</B><BR>";

    foreach my $userid (@opusers) {
      SendSQL("UPDATE profiles SET groupset=$opblessgroupset " .
              "WHERE userid=$userid");
      print "׷ Ʈ " . DBID_to_name($userid) .
            "  Ǿϴ. ()<BR>\n";
    }

    PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
    exit;
}

#
# action='update' -> update the groups
#

if ($action eq 'update') {
    PutHeader("׷ ϱ");

    my $chgs = 0;

    foreach my $b (grep(/^name-\d*$/, keys %::FORM)) {
        if ($::FORM{$b}) {
            my $v = substr($b, 5);

# print "Old: '" . $::FORM{"oldname-$v"} . "', '" . $::FORM{"olddesc-$v"} .
#      "', '" . $::FORM{"oldregexp-$v"} . "'<br>";
# print "New: '" . $::FORM{"name-$v"} . "', '" . $::FORM{"desc-$v"} .
#      "', '" . $::FORM{"regexp-$v"} . "'<br>";

            if ($::FORM{"oldname-$v"} ne $::FORM{"name-$v"}) {
                $chgs = 1;
                SendSQL("SELECT name FROM groups WHERE name=" .
                         SqlQuote($::FORM{"name-$v"}));
                if (!FetchOneColumn()) {
                    SendSQL("SELECT name FROM groups WHERE name=" .
                             SqlQuote($::FORM{"oldname-$v"}) .
                             " && isbuggroup = 0");
                    if (FetchOneColumn()) {
                        ShowError("ý ׷ ̸   ϴ. ׷ $v / ǳʶݴϴ.");
                    } else {
                        SendSQL("UPDATE groups SET name=" .
                                SqlQuote($::FORM{"name-$v"}) .
                                " WHERE bit=" . SqlQuote($v));
                        print "׷ $v ̸ ŵǾϴ.<br>\n";
                    }
                } else {
                    ShowError("׷ $v  ̸('" . $::FORM{"name-$v"} .
                              "') ߺǾϴ.<BR>" .
                              "׷ $v ̸ ſû ǳʶݴϴ.");
                }
            }
            if ($::FORM{"olddesc-$v"} ne $::FORM{"desc-$v"}) {
                $chgs = 1;
                SendSQL("SELECT description FROM groups WHERE description=" .
                         SqlQuote($::FORM{"desc-$v"}));
                if (!FetchOneColumn()) {
                    SendSQL("UPDATE groups SET description=" .
                            SqlQuote($::FORM{"desc-$v"}) .
                            " WHERE bit=" . SqlQuote($v));
                    print "׷ $v  ŵǾϴ.<br>\n";
                } else {
                    ShowError("׷ $v  ('" . $::FORM{"desc-$v"} .
                              "') ߺǾϴ.<BR>" .
                              "׷ $v  ſû ǳʶݴϴ.");
                }
            }
            if ($::FORM{"oldregexp-$v"} ne $::FORM{"regexp-$v"}) {
                $chgs = 1;
                SendSQL("UPDATE groups SET userregexp=" .
                        SqlQuote($::FORM{"regexp-$v"}) .
                        " WHERE bit=" . SqlQuote($v));
                print "׷ $v  ǥ ŵǾϴ.<br>\n";
            }
            # convert an undefined value in the inactive field to zero
            # (this occurs when the inactive checkbox is not checked 
            # and the browser does not send the field to the server)
            my $isactive = $::FORM{"isactive-$v"} || 0;
            if ($::FORM{"oldisactive-$v"} != $isactive) {
                $chgs = 1;
                if ($isactive == 0 || $isactive == 1) {
                    SendSQL("UPDATE groups SET isactive=$isactive" .
                            " WHERE bit=" . SqlQuote($v));
                    print "׷ $v Ȱȭ ÷װ ŵǾϴ.<br>\n";
                } else {
                    ShowError("ԷϽ ('" . $isactive .
                              "') Ȱȭ ÷׿ ȿ  Դϴ.<BR>" .
                              "  ߻Ͽų,   װ ִ   ֽϴ.<br>" . 
                              "׷ $v  Ȱȭ ÷ ſû ǳʶݴϴ.");
                }
            }
        }
    }
    if (!$chgs) {
        print "ϲ  ׸ ϴ!<BR>\n";
        print " Ϸ ǵ , <B>ڷ(Back)</B> ư ŬϽ  ٽ õ ֽʽÿ.<p>\n";
    } else {
        print "ϷǾϴ.<p>\n";
    }
    PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
    exit;
}

#
# No valid action found
#

PutHeader("");
print "ϲ  Ͻô   ϰڽϴ.<BR>\n";

foreach ( sort keys %::FORM) {
    print "$_: $::FORM{$_}<BR>\n";
}

PutTrailer("<a href=editgroups.cgi>׷ Ʈ ư</a>");
