#!/usr/bonsaitools/bin/perl -wT
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
#   빰   ̼ (Mozilla Public License
# Version -  "̼") 1.1  ȣ˴ϴ. ̼ 
# ʴ    Ͻ  ϴ. ̼  纻
# http://www.mozilla.org/MPL/  Ͻ  ֽϴ.
#
# MPL ̼ Ͽ Ǵ Ʈ "ִ ״" Ǵ 
# Ģ մϴ.   Ʈ ε ε  
#     ʽϴ. Ѱ ׵鿡   ڼ
#  ̼ Ͻñ ٶϴ.
#
#  ڵ    ý(Bugzilla Bug Tracking System)
# Դϴ.
#
#  ڵ ʱ  "ݽ Ŀ´̼ ۷̼"  
#  Ӵϴ.  ǰ Ϻ  Netscape 信    Copyright
# (C) 1998 Netscape Communications Corporation  ȣǸ,  
#  Netscape ֽϴ.
#
# Contributor(s): Dawn Endico    <endico@mozilla.org>
#                 Terry Weissman <terry@mozilla.org>

use diagnostics;
use strict;

use lib qw(.);

use Bug;
require "CGI.pl";
$::lockcount = 0;

unless ( Param("move-enabled") ) {
  print "\n<P>˼մϴ.    ̵   ϴ. ";
  print " ׸ ̵ϼž ʿ䰡 ִٸ, (" . 
        Param("maintainer") . ") ϼ.";
  exit;
}

ConnectToDatabase();
confirm_login();

sub Log {
    my ($str) = (@_);
    Lock();
    open(FID, ">>data/maillog") || die "data/maillog    ϴ.";
    print FID time2str("%D %H:%M", time()) . ": $str\n";
    close FID;
    Unlock();
}

sub Lock {
    if ($::lockcount <= 0) {
        $::lockcount = 0;
        open(LOCKFID, ">>data/maillock") || die "data/maillock    ϴ.: $!";
        my $val = flock(LOCKFID,2);
        if (!$val) { # '2' is magic 'exclusive lock' const.
            print "Content-type: text/html\n\n";
            print "(Lock) Ͽϴ: $val\n";
        }
        chmod 0666, "data/maillock";
    }
    $::lockcount++;
}

sub Unlock {
    $::lockcount--;
    if ($::lockcount <= 0) {
        flock(LOCKFID,8);       # '8' is magic 'unlock' const.
        close LOCKFID;
    }
}

if ( !defined $::FORM{'buglist'} ) {
  print "Content-type: text/html\n\n";
  PutHeader("Move Bugs");
  print " ̵ '  ' ";
  print "<A HREF=\"query.cgi\"> </A>Ͽ ó  , ";
  print "ټ ׵     ֽϴ.\n";
  print " '̵' ư  Ŵٸ, α ̰ų ";
  print "̵   ο  Դϴ.";
  PutFooter();
  exit;
}

my $exporter = $::COOKIE{"Bugzilla_login"};
my $movers = Param("movers");
$movers =~ s/\w?,\w?/|/g;
$movers =~ s/@/\@/g;
unless ($exporter =~ /($movers)/) {
  print "Content-type: text/html\n\n";
  PutHeader("Move Bugs");
  print "<P>ϲ ׸ ̵  ִ    ʽϴ.<P>\n";
  PutFooter();
  exit;
}

my $xml = "";
$xml .= Bug::XML_Header( Param("urlbase"), $::param{'version'}, 
                         Param("maintainer"), $exporter );
print "<P>\n";
foreach my $id (split(/:/, $::FORM{'buglist'})) {
  my $bug = new Bug($id, $::userid);
  $xml .= $bug->emitXML;
  if (!$bug->error) {
    my $exporterid = DBNameToIdAndCheck($exporter);

    my $fieldid = GetFieldID("bug_status");
    my $cur_status= $bug->bug_status;
    SendSQL("INSERT INTO bugs_activity " .
            "(bug_id,who,bug_when,fieldid,removed,added) VALUES " .
            "($id,$exporterid,now(),$fieldid,'$cur_status','RESOLVED')");
    $fieldid = GetFieldID("resolution");
    my $cur_res= $bug->resolution;
    SendSQL("INSERT INTO bugs_activity " .
            "(bug_id,who,bug_when,fieldid,removed,added) VALUES " .
            "($id,$exporterid,now(),$fieldid,'$cur_res','MOVED')");

    SendSQL("UPDATE bugs SET bug_status =\"RESOLVED\" where bug_id=\"$id\"");
    SendSQL("UPDATE bugs SET resolution =\"MOVED\" where bug_id=\"$id\"");

    my $comment = "";
    if (defined $::FORM{'comment'} && $::FORM{'comment'} !~ /^\s*$/) {
        $comment .= $::FORM{'comment'} . "\n\n";
    }
    $comment .= "װ " . Param("move-to-url") . " () ̵Ͽϴ.\n\n";
    $comment .= "۾  ϷǾٸ, $exporter Բ ̵ \n";
    $comment .= " ͺ̽ ȹ ο  ȣ Ϸ \n";
    $comment .= "۵ Դϴ.    ȴٸ,  ׸ \n";
    $comment .= "VERIFIED () · ǥϽð, ο ׿  \n";
    $comment .= "ũ ٿ ־ ֽʽÿ.   ߻Ͽٸ,  \n";
    $comment .= "׸ REOPENED (ٽ µ) · ñ ٶϴ.\n";
    SendSQL("INSERT INTO longdescs (bug_id, who, bug_when, thetext) VALUES " .
        "($id,  $exporterid, now(), " . SqlQuote($comment) . ")");

    print "<P> $id / " . Param("move-to-url") . " () ̵Ͽϴ.<BR>\n";
    system("./processmail", $id, $exporter);
  }
}
print "<P>\n";
$xml .= Bug::XML_Footer;

my $buglist = $::FORM{'buglist'};
$buglist =~ s/:/,/g;
my $host = Param("urlbase");
$host =~ s#http://([^/]+)/.*#$1#;
my $to = Param("move-to-address");
$to =~ s/@/\@/;
my $msg = "To: $to\n";
my $from = Param("moved-from-address");
$from =~ s/@/\@/;
$msg .= "From:  <" . $from . ">\n";
$msg .= "Subject: װ ̵Ǿϴ: $buglist\n\n";
$msg .= $xml . "\n";

open(SENDMAIL,
  "|/usr/lib/sendmail -ODeliveryMode=background -t -i") ||
    die "sendmail   ϴ.";
print SENDMAIL $msg;
close SENDMAIL;

my $logstr = "XML:  $buglist  $to  ̵Ǿϴ.";
Log($logstr);
