#!/usr/bonsaitools/bin/perl -w
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
#   빰   ̼ (Mozilla Public License
# Version -  "̼") 1.1  ȣ˴ϴ. ̼ 
# ʴ    Ͻ  ϴ. ̼  纻
# http://www.mozilla.org/MPL/  Ͻ  ֽϴ.
#
# MPL ̼ Ͽ Ǵ Ʈ "ִ ״" Ǵ 
# Ģ մϴ.   Ʈ ε ε  
#     ʽϴ. Ѱ ׵鿡   ڼ
#  ̼ Ͻñ ٶϴ.
#
#  ڵ    ý(Bugzilla Bug Tracking System)
# Դϴ.
#
#  ڵ ʱ  "ݽ Ŀ´̼ ۷̼"  
#  Ӵϴ.  ǰ Ϻ  Netscape 信    Copyright
# (C) 1998 Netscape Communications Corporation  ȣǸ,  
#  Netscape ֽϴ.
#
# Contributor(s): Terry Weissman <terry@mozilla.org>


# This is a script suitable for running once a day from a cron job.  It 
# looks at all the bugs, and sends whiny mail to anyone who has a bug 
# assigned to them that has status NEW that has not been touched for
# more than 7 days.

use diagnostics;
use strict;

require "globals.pl";

ConnectToDatabase();

SendSQL("select bug_id,login_name from bugs,profiles where " .
        "bug_status = 'NEW' and to_days(now()) - to_days(delta_ts) > " .
        Param('whinedays') . " and userid=assigned_to order by bug_id");

my %bugs;
my @row;

while (@row = FetchSQLData()) {
    my ($id, $email) = (@row);
    if (!defined $bugs{$email}) {
        $bugs{$email} = [];
    }
    push @{$bugs{$email}}, $id;
}


my $template = Param('whinemail');
my $urlbase = Param('urlbase');
my $emailsuffix = Param('emailsuffix');

foreach my $email (sort (keys %bugs)) {
    my %substs;
    $substs{'email'} = $email . $emailsuffix;
    $substs{'userid'} = $email;
    my $msg = PerformSubsts($template, \%substs);

    foreach my $i (@{$bugs{$email}}) {
        $msg .= "  ${urlbase}show_bug.cgi?id=$i\n"
    }

    my $sendmailparam = Param('sendmailnow') ? '' : "-ODeliveryMode=deferred";
    open SENDMAIL, "|/usr/lib/sendmail $sendmailparam -t -i"
        or die "sendmail   ϴ.";
    print SENDMAIL $msg;
    close SENDMAIL;
    print "$email      " . join(" ", @{$bugs{$email}}) . "\n";
}
